﻿using MySql.Data.MySqlClient;
using System;
using Microsoft.EntityFrameworkCore;
using MySQL.Data.EntityFrameworkCore.Extensions;
using System.ComponentModel.DataAnnotations.Schema;

namespace MySQLTest
{
    [Table("test")]
    public class TestDto
    {
        [Column("id")]
        public int Id { get; set; }
        [Column("date")]
        public DateTime Date { get; set; }
    }

    public class TestDbContext : DbContext
    {
        public static string CON_STR = "Server=localhost;User Id=test;Password=test;Database=mysql-datetime-test;Convert Zero Datetime=True;Ssl-Mode=None";

        public TestDbContext() : base()
        {

        }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            optionsBuilder.UseMySQL(CON_STR);
            base.OnConfiguring(optionsBuilder);
        }

        public DbSet<TestDto> Entries { get; set; }
    }

    class Program
    {
        static void Main(string[] args)
        {
            var connection = new MySqlConnection(TestDbContext.CON_STR);
            connection.Open();

            string sql = "CREATE TABLE IF NOT EXISTS `mysql-datetime-test`.`test` ( `id` INT NOT NULL AUTO_INCREMENT , `date` DATETIME NOT NULL , PRIMARY KEY (`id`))";
            MySqlCommand cmd = new MySqlCommand(sql, connection);
            cmd.ExecuteNonQuery();

            sql = "INSERT INTO `test` (`date`) VALUES('0000-00-00');";
            cmd = new MySqlCommand(sql, connection);
            cmd.ExecuteScalar();

            connection.Close();

            using (var ctx = new TestDbContext())
            {
                // Throws exception
                foreach (var entry in ctx.Entries)
                {
                    Console.WriteLine($"{entry.Id} {entry.Date}");
                }
            }
        }
    }
}